EXIF library (libexif) API 0.6.25

Data Structures | Macros | Typedefs | Functions
exif-entry.h File Reference

Handling EXIF entries. More...

`#include <libexif/exif-content.h>`
`#include <libexif/exif-format.h>`
`#include <libexif/exif-mem.h>`

Go to the source code of this file.

## Data Structures
struct | _ExifEntry
| Data found in one EXIF tag. More...

## Macros
#define | exif_entry_get_ifd(e) ((e)?exif_content_get_ifd((e)->parent):EXIF_IFD_COUNT)
| Return the IFD number of the given ExifEntry.

## Typedefs
typedef struct _ExifEntry | ExifEntry
| Data found in one EXIF tag.
typedef struct _ExifEntryPrivate | ExifEntryPrivate

## Functions
ExifEntry * | exif_entry_new (void)
| Reserve memory for and initialize a new ExifEntry.
ExifEntry * | exif_entry_new_mem (ExifMem *)
| Reserve memory for and initialize new ExifEntry using the specified memory allocator.
void | exif_entry_ref (ExifEntry *entry)
| Increase reference counter for ExifEntry.
void | exif_entry_unref (ExifEntry *entry)
| Decrease reference counter for ExifEntry.
void | exif_entry_free (ExifEntry *entry)
| Actually free the ExifEntry.
void | exif_entry_initialize (ExifEntry *e, ExifTag tag)
| Initialize an empty ExifEntry with default data in the correct format for the given tag.
void | exif_entry_fix (ExifEntry *entry)
| Fix the type or format of the given EXIF entry to bring it into spec.
const char * | exif_entry_get_value (ExifEntry *entry, char *val, unsigned int maxlen)
| Return a localized textual representation of the value of the EXIF entry.
void | exif_entry_dump (ExifEntry *entry, unsigned int indent)
| Dump text representation of ExifEntry to stdout.

## Detailed Description

Handling EXIF entries.

## Macro Definition Documentation

## ◆ exif_entry_get_ifd

#define exif_entry_get_ifd | ( |  | e | ) | ((e)?exif_content_get_ifd((e)->parent):EXIF_IFD_COUNT)

Return the IFD number of the given ExifEntry.

Parameters

  [in] | e | an ExifEntry*

Returns
  ExifIfd, or EXIF_IFD_COUNT on error

## Typedef Documentation

## ◆ ExifEntry

typedef struct _ExifEntry ExifEntry

Data found in one EXIF tag.

The exif_entry_get_value function can provide access to the formatted contents, or the struct members can be used directly to access the raw contents.

## Function Documentation

## ◆ exif_entry_dump()

void exif_entry_dump | ( | ExifEntry * | entry,
|  | unsigned int | indent
| ) |  |

Dump text representation of ExifEntry to stdout.

This is intended for diagnostic purposes only.

Parameters

  [in] | entry | EXIF tag data
  [in] | indent | how many levels deep to indent the data

References _ExifEntry::components, exif_entry_get_ifd, _ExifEntry::format, _ExifEntry::size, and _ExifEntry::tag.

## ◆ exif_entry_fix()

void exif_entry_fix | ( | ExifEntry * | entry | ) |

Fix the type or format of the given EXIF entry to bring it into spec.

If the data for this EXIF tag is in of the wrong type or is in an invalid format according to the EXIF specification, then it is converted to make it valid. This may involve, for example, converting an EXIF_FORMAT_LONG into a EXIF_FORMAT_SHORT. If the tag is unknown, its value is untouched.

Note
  Unfortunately, some conversions are to a type with a more restricted range, which could have the side effect that the converted data becomes invalid. This is unlikely as the range of each tag in the standard is designed to encompass all likely data.

Parameters

  [in,out] | entry | EXIF entry

References _ExifEntry::components, _ExifEntry::data, exif_entry_get_ifd, _ExifEntry::format, _ExifContent::parent, _ExifEntry::parent, _ExifEntry::priv, _ExifEntry::size, and _ExifEntry::tag.

## ◆ exif_entry_free()

void exif_entry_free | ( | ExifEntry * | entry | ) |

Actually free the ExifEntry.

Deprecated:
  Should not be called directly. Use exif_entry_ref and exif_entry_unref instead.

Parameters

  [in] | entry | EXIF entry

References _ExifEntry::data, and _ExifEntry::priv.

## ◆ exif_entry_get_value()

const char * exif_entry_get_value | ( | ExifEntry * | entry,
|  | char * | val,
|  | unsigned int | maxlen
| ) |  |

Return a localized textual representation of the value of the EXIF entry.

This is meant for display to the user. The format of each tag is subject to change between locales and in newer versions of libexif. Users who require the tag data in an unambiguous form should access the data members of the ExifEntry structure directly.

Warning
  The character set of the returned string may be in the encoding of the current locale or the native encoding of the camera.

Bug:
  The EXIF_TAG_XP_* tags are currently always returned in UTF-8, regardless of locale, and code points above U+FFFF are not supported.

Parameters

  [in] | entry | EXIF entry
  [out] | val | buffer in which to store value; if entry is valid and maxlen > 0 then this string will be NUL-terminated
  [in] | maxlen | length of the buffer val

Returns
  val pointer

References _ExifEntry::components, _ExifEntry::data, _ExifEntry::format, _ExifData::ifd, _ExifContent::parent, _ExifEntry::parent, _ExifEntry::priv, _ExifEntry::size, and _ExifEntry::tag.

## ◆ exif_entry_initialize()

void exif_entry_initialize | ( | ExifEntry * | e,
|  | ExifTag | tag
| ) |  |

Initialize an empty ExifEntry with default data in the correct format for the given tag.

If the entry is already initialized, this function does nothing. This call allocates memory for the `data` element of the given ExifEntry. That memory is freed at the same time as the ExifEntry.

Parameters

  [out] | e | entry to initialize
  [in] | tag | tag number to initialize as

Bug:
  Log and report failed exif_mem_malloc() calls.

References _ExifEntry::components, _ExifEntry::data, exif_entry_get_ifd, _ExifEntry::format, _ExifContent::parent, _ExifEntry::parent, _ExifEntry::size, and _ExifEntry::tag.

## ◆ exif_entry_new()

ExifEntry * exif_entry_new | ( | void |  | ) |

Reserve memory for and initialize a new ExifEntry.

No memory is allocated for the `data` element of the returned ExifEntry.

Returns
  new allocated ExifEntry, or NULL on error

See also
  exif_entry_new_mem, exif_entry_unref

## ◆ exif_entry_new_mem()

ExifEntry * exif_entry_new_mem | ( | ExifMem * | mem | ) |

Reserve memory for and initialize new ExifEntry using the specified memory allocator.

No memory is allocated for the `data` element of the returned ExifEntry.

Returns
  new allocated ExifEntry, or NULL on error

See also
  exif_entry_new, exif_entry_unref

References _ExifEntry::priv.

## ◆ exif_entry_ref()

void exif_entry_ref | ( | ExifEntry * | entry | ) |

Increase reference counter for ExifEntry.

Parameters

  [in] | entry | ExifEntry

See also
  exif_entry_unref

References _ExifEntry::priv.

## ◆ exif_entry_unref()

void exif_entry_unref | ( | ExifEntry * | entry | ) |

Decrease reference counter for ExifEntry.

When the reference count drops to zero, free the entry.

Parameters

  [in] | entry | ExifEntry

References _ExifEntry::priv.